/******************************************************************************/
/*!
\file   global.fx
\author Jonathan Hurtado
\date   3/30/2010
\brief

	Most of the HLSL shaders in our game use the variables defined in this file.

All content  2010 DigiPen (USA) Corporation, all rights reserved.
*/
/******************************************************************************/

float4x4 worldViewProj : WorldViewProjection;
float4x4 world : World;
static const int MaxMatrices = 80;
float4x3   WorldMatrixArray[MaxMatrices] : WORLDMATRIXARRAY;

struct light
{
	float3 pos;     // position of the light in world space
	float3 direction;  // direction of light (used for direction and point lights)
	float4 ambient;  // ambient color of light
	float4 diffuse;  // diffuse color of light
	float4 specular; // specular color of light
	float radius;    // radius of light
	float spotPower; // power of the spotlight
	float activationTime; // The time the light was activated
	int type;  // 1 = point light, 2 = spotlight, 3 = directional light
};

light dirLights[5];


uniform extern float4 gDiffuseMtrl;
uniform extern float4 gAmbientMtrl;
uniform extern float4 gSpecularMtrl;
uniform extern float  gSpecPower;

uniform extern float3 gEyePosW; 
uniform extern float gTime;

struct VS_INPUT
{
	float3 position	: POSITION;
	float3 normal : NORMAL;
	float2 tex0 : TEXCOORD0;
	
};

struct VS_INPUT_SKIN
{
    float4 position	: POSITION;
    float3 normal : NORMAL;
    float2 tex0 : TEXCOORD0;
    float4 BlendWeights : BLENDWEIGHT;
    float4 BlendIndices : BLENDINDICES;
};


struct VS_OUTPUT_TRUE
{
    float4 pos : POSITION;
	float3 worldpos : TEXCOORD0;
	float2 tex0  : TEXCOORD1;
    float3 normal : TEXCOORD2;
};
